//  
//  Author:
//       smdn <smdn@smdn.jp>
// 
//  Copyright (c) 2003-2013 smdn
// 
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
//  GNU General Public License for more details.
//  
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

using System;
using System.Text.RegularExpressions;

using Smdn.IO.FileSystems;

namespace Smdn.Applications.DirectoryAnalyzer.Analysis {
  public class Analyzer {
    private AnalysisContext context = null;

    public Analyzer(AnalysisContext context)
    {
      if (null == context) throw new ArgumentNullException("context");

      this.context = context;
    }

    public void Analyze()
    {
#if false
      if (context.Parameter.PreAnalyze)
      {
        // ディレクトリ内を先行走査
        context.Status.StatusText = "ディレクトリ内のエントリ数を取得中";

        DirectoryUtils.GetEntryCount(context.Parameter.AnalysisDirectory, true, ref context.Status.EntryCount);
      }
#endif

      // 対象ディレクトリを走査
      context.Status.StatusText = "ディレクトリを解析中";

      //context.Result.Tree = Tree.Create(context.Parameter.AnalysisDirectory, context.Status, context.Parameter.ScanPredicate);
      context.Result.DirectoryTree = DirectoryTree.Create(context.Parameter.AnalysisDirectory, context.Parameter.ScanPredicate, delegate(IProgress progress) {
        context.Status.StatusText = progress.StatusText;
      });

      context.Status.StatusText = "ディレクトリの解析が完了しました";
    }
  }
}